#version 330 core
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 texCoord;
layout (location = 3) in vec3 tangent;
layout (location = 4) in vec3 bitangent;


out VS_OUT {

	 vec2 TexCoord;
	 vec3 FragPos;
	 mat3 TBN;
	 vec3 Normal;
	 // needed when normal mapping is turned off



	 	 } vs_out;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;

uniform vec3 lightPos;
uniform vec3 viewPos;

void main()
{
    gl_Position = projection * view * model * vec4(position, 1.0f);

	vs_out.TexCoord = texCoord;
    
	 
    
	// go to worldspace
	vs_out.FragPos = vec3(model * vec4(position, 1.0f));
	


	 mat3 normalMatrix = transpose(inverse(mat3(model)));
	
    vec3 T = normalize(normalMatrix * tangent);
    vec3 B = normalize(normalMatrix * bitangent);
    vec3 N = normalize(normalMatrix * normal);    
	vs_out.Normal = N;
    if (dot(cross(N, T), B) < 0.0)
                T = T * -1.0;
   // TBN = mat3(T, B, N);
   vs_out.TBN = mat3(T, B, N);
  
   
   
} 