#version 330 core
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 texCoord;
layout (location = 3) in vec3 tangent;
layout (location = 4) in vec3 bitangent;

out vec2 TexCoord;
out vec3 Normal;
out vec3 FragPos;

out mat3 TBN;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;



void main()
{
    gl_Position = projection * view * model * vec4(position, 1.0f);

    TexCoord = texCoord;

    // go to worldspace
	FragPos = vec3(model * vec4(position, 1.0f));


	    // go to world space
	// could make transpose inverse model matrix uniform, faster 
	// create the normal matrix
/*	  Normal = mat3(transpose(inverse(model))) * normal;

	  mat3 normalMatrix = transpose(inverse(mat3(model)));
    vec3 T = normalize(normalMatrix * tangent);
    vec3 B = normalize(normalMatrix * bitangent);
    vec3 N = normalize(normalMatrix * normal);    
    
    mat3 TBN = transpose(mat3(T, B, N));  
    TangentLightPos = TBN * lightPos;
   TangentViewPos  = TBN * viewPos;
   TangentFragPos  = TBN * FragPos;
   */

   	 mat3 normalMatrix = transpose(inverse(mat3(model)));
	
    vec3 T = normalize(normalMatrix * tangent);
    vec3 B = normalize(normalMatrix * bitangent);
    vec3 N = normalize(normalMatrix * normal);    
	Normal = N;
    if (dot(cross(N, T), B) < 0.0)
                T = T * -1.0;
   // TBN = mat3(T, B, N);
 TBN = mat3(T, B, N);
  
}

 