#version 330 core
layout (triangles) in;
layout (triangle_strip, max_vertices = 3) out;

in VS_OUT {
     vec2 TexCoord;
	 vec3 FragPos;
	 vec3 TangentLightPos;
	 vec3 TangentViewPos;
	 vec3 TangentFragPos;
	 
 	 vec3 ViewPos;
	 vec3 Normal;
} gs_in[];


out vec2 TexCoord;
out vec3 FragPos;
out vec3 TangentLightPos;
out vec3 TangentViewPos;
out vec3 TangentFragPos;

out vec3 ViewPos;
out vec3 Normals;

uniform float time;

vec4 explode(vec4 position, vec3 normal)
{
    float magnitude = 2.0f;
    vec3 direction = normal * ((sin(time) + 1.0f) / 2.0f) * magnitude; 
    return position + vec4(direction, 0.0f);
}

void main() {
		 vec3 normal = gs_in[0].Normal;
	

 //   gl_Position = explode(gl_in[0].gl_Position, normal);
   gl_Position = gl_in[0].gl_Position;
	TexCoord = gs_in[0].TexCoord;
	FragPos = gs_in[0].FragPos;
 	TangentLightPos = gs_in[0].TangentLightPos;
	TangentViewPos = gs_in[0].TangentViewPos;
	TangentFragPos = gs_in[0].TangentFragPos;

	Normals = gs_in[0].Normal;
	ViewPos = gs_in[0].ViewPos;
    EmitVertex();
//	gl_Position = explode(gl_in[1].gl_Position, normal);
    gl_Position = gl_in[1].gl_Position;
	TexCoord = gs_in[1].TexCoord;
	FragPos = gs_in[1].FragPos;
	TangentLightPos = gs_in[1].TangentLightPos;
	TangentViewPos = gs_in[1].TangentViewPos;
	TangentFragPos = gs_in[1].TangentFragPos;

	Normals = gs_in[1].Normal;
	ViewPos = gs_in[1].ViewPos;

    EmitVertex();

//	    gl_Position = explode(gl_in[2].gl_Position, normal);
   gl_Position = gl_in[2].gl_Position;
	TexCoord = gs_in[2].TexCoord;
	FragPos = gs_in[2].FragPos;
	TangentLightPos = gs_in[2].TangentLightPos;
	TangentViewPos = gs_in[2].TangentViewPos;
	TangentFragPos = gs_in[2].TangentFragPos;

	Normals = gs_in[2].Normal;
	ViewPos = gs_in[2].ViewPos;

    EmitVertex();

    EndPrimitive();
}  